package org.antlr.codegen;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.util.Set;
import org.antlr.Tool;
import org.antlr.codegen.CodeGenerator;
import org.antlr.codegen.Target;
import org.antlr.tool.Grammar;
import org.antlr.tool.Rule;
import org.stringtemplate.v4.ST;

public class JavaTarget extends Target {
  public boolean useBaseTemplatesForSynPredFragments() {
    return false;
  }
  
  protected ST chooseWhereCyclicDFAsGo(Tool tool, CodeGenerator generator, Grammar grammar, ST recognizerST, ST cyclicDFAST) {
    return recognizerST;
  }
  
  protected void performGrammarAnalysis(CodeGenerator generator, Grammar grammar) {
    super.performGrammarAnalysis(generator, grammar);
    for (Rule rule : grammar.getRules())
      rule.throwsSpec.add("RecognitionException"); 
    Set<? extends Rule> delegatedRules = grammar.getDelegatedRules();
    if (delegatedRules != null)
      for (Rule rule : delegatedRules)
        rule.throwsSpec.add("RecognitionException");  
  }
}
